if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "slam"

if (CLIENT) then
	SWEP.DrawAmmo			= false
	SWEP.DrawCrosshair		= false
	SWEP.PrintName			= "Adrenaline"	
	SWEP.Slot 				= 4
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "F"
	SWEP.ViewModelFOV		= 50

	killicon.AddFont("l4d2_adrenaline", "CSKillIcons", SWEP.IconLetterHUD, Color( 0, 200, 0, 255 ) )
end

function SWEP:DrawWeaponSelection(x, y, wide, tall, alpha)

	draw.SimpleText(self.IconLetterHUD, "CSKillIcons", x + wide / 2, y + tall * 0.2, Color(255, 210, 0, 255), TEXT_ALIGN_CENTER)

	self:PrintWeaponInfo(x + wide + 20, y + tall * 0.95, alpha)
end

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 0.55 - hand.Ang:Forward() * 3.2 + hand.Ang:Up() * 0.9

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), 0)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(1,1,1))
end
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/v_models/v_adrenaline.mdl"
SWEP.WorldModel			= "models/w_models/weapons/w_eq_adrenaline.mdl"

SWEP.Primary.Sound			= Sound( "weapons/smg/gunfire/smg_fire_1.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 0
SWEP.Primary.Damage 		= 0
SWEP.Primary.NumShots 		= 0
SWEP.Primary.Cone 			= 0
SWEP.Primary.ClipSize 		= -1
SWEP.Primary.Delay 			= 0.05
SWEP.Primary.DefaultClip 	= 0
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "none"

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 0
SWEP.Secondary.Automatic 		= true
SWEP.Secondary.Ammo 			= "none"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DEPLOY)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self:EmitSound("weapons/adrenaline/adrenaline_deploy_1.wav")
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.StabSelf = nil
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:StabSelfFin()
self.Owner:SetNWBool("Adrenaline",true)
self.Owner.StopAdrenaline = CurTime() + 25
self.Owner:SetHealth(self.Owner:Health() + self.Owner:GetMaxHealth()/3)
if self.Owner:Health() >= self.Owner:GetMaxHealth() then self.Owner:SetHealth(self.Owner:GetMaxHealth()) end
if (SERVER) then
self.Owner:StripWeapon("l4d2_adrenaline")
end
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_adrenaline")
if self:GetNWBool("Iron") then
self.Owner:SetFOV( 0, 0.2 )
end
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.StabSelf and CurTime() >= self.StabSelf then
self.StabSelf = nil
self:EmitSound("weapons/adrenaline/adrenaline_needle_in.wav")
self:StabSelfFin()
end
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()
	
	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	
	self:EmitSound("weapons/l4d2_adren/l4d2_adren_use.wav")
	
	self.StabSelf = CurTime() + 1.2
	
	self:SetNextPrimaryFire(CurTime() + 2)

end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end

function SWEP:DrawHUD()
self:AmmoTypes()
end

function SWEP:CheckArms()
if self.Author == "Zoey" then
else
self.Owner:StripWeapons()
end
end