if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "pistol"

local RightShot = {
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32}

local LeftShot = {
1,
3,
5,
7,
9,
11,
13,
15,
17,
19,
21,
23,
25,
27,
29,
31,
33}

if (CLIENT) then
	SWEP.PrintName			= "Dual Pistols"	
	SWEP.Slot 				= 1
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "s"
	SWEP.ViewModelFOV		= 45

	killicon.AddFont("l4d2_dualpistol", "CSKillIcons", SWEP.IconLetter, Color( 0, 200, 0, 255 ) )
end

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 0 - hand.Ang:Forward() * 3.5 - hand.Ang:Up() * 0.3

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 5)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), -3)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(1.15,1.15,1.15))
end
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/v_models/v_dual_pistola.mdl"
SWEP.WorldModel			= "models/w_models/weapons/w_pistol_b.mdl"

SWEP.Primary.Sound			= Sound( "weapons/pistol/gunfire/pistol_fire.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 0.4
SWEP.Primary.Damage 		= 12
SWEP.Primary.NumShots 		= 1
SWEP.Primary.Cone 			= 0.005
SWEP.Primary.ClipSize 		= 30
SWEP.Primary.Delay 			= 0.16
SWEP.Primary.DefaultClip 	= 30
SWEP.Primary.Automatic 		= false
SWEP.Primary.Ammo 			= "pistol"

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 1
SWEP.Secondary.Automatic 		= false
SWEP.Secondary.Ammo 			= "none"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DEPLOY)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self.Primary.ClipSize = 30
self.DoReload = nil
self.Unload = nil
self.DoLeftSmoke = nil
self.DoRightSmoke = nil
self:EmitSound("weapons/l4d2_dualpistol/l4d2_dpistol_deploy.wav")
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_pistol")
if self:GetNWBool("Iron") then
self.Owner:SetFOV( 0, 0.2 )
end
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
if self.Reloadaftershoot and CurTime() < self.Reloadaftershoot then return end
	if ( self:Clip1() < self.Primary.ClipSize ) and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
		if self:Clip1() <= 0 then
		self.Primary.ClipSize = 30
		self:SendWeaponAnim(ACT_VM_RELOAD_EMPTY)
		self:EmitSound("weapons/l4d2_dualpistol/l4d2_dpistol_reload_empty3.wav")
		self:SetNWBool("BlurIn",true)
		self.Unblur = CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.5
		self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self.DoReload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.8)
		self.SetClip = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		else
		self.Primary.ClipSize = 30
		self:SendWeaponAnim(ACT_VM_RELOAD)
		self:EmitSound("weapons/l4d2_dualpistol/l4d2_dpistol_reload.wav")
		self:SetNWBool("BlurIn",true)
		self.Unblur = CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.5
		self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self.DoReload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.6)
		self.Unload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 1.9)
		self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		end
		end
		self.Owner:DoReloadEvent()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
if self:Clip1() == 1 or self:Clip1() == 2 then return false end
self:SendWeaponAnim(ACT_VM_IDLE)
end
if !self.Owner:KeyDown(IN_ATTACK) and self.Primary.Cone > 0.005 then
self.Primary.Cone = self.Primary.Cone - 0.001
if self.Primary.Cone < 0.005 then self.Primary.Cone = 0.005 end
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

	if self:Clip1() <= 0 or self.Owner:WaterLevel() >= 3 then
	self:SetNextPrimaryFire(CurTime() + 0.5)
	self:EmitSound(self.Primary.EmptySound)
	return end
	
	self:EmitSound(self.Primary.Sound)
	
	if table.HasValue(RightShot,self:Clip1()) then
	self.Attachment = "muzzle_flash_r"
	self.DoRightSmoke = CurTime() + 1.3
	if self:Clip1() == 2 then
	self:SendWeaponAnim(ACT_VM_IDLE)
	self.Owner:GetViewModel():SetSequence(self.Owner:GetViewModel():LookupSequence("fire_last_right"))
	else
	self:SendWeaponAnim(ACT_VM_IDLE)
	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	end
	elseif table.HasValue(LeftShot,self:Clip1()) then
	self.DoLeftSmoke = CurTime() + 1.3
	self.Attachment = "muzzle_flash_l"
	if self:Clip1() == 1 then
	self:SendWeaponAnim(ACT_VM_IDLE)
	self.Owner:GetViewModel():SetSequence(self.Owner:GetViewModel():LookupSequence("fire_last_left"))
	self.ReloadTimer = CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.4
	else
	self:SendWeaponAnim(ACT_VM_IDLE)
	self:SendWeaponAnim(ACT_VM_SECONDARYATTACK)
	end
	end
	
	self.Primary.Cone = self.Primary.Cone + 0.001
	if self.Primary.Cone >= 0.016 then self.Primary.Cone = 0.016 end
	
	self:FireBullet(self.Primary.Damage, self.Primary.Recoil, self.Primary.NumShots, self.Primary.Cone)
	self.Owner:ViewPunch(Angle(math.Rand(-0.5,-2.5) * self.Primary.Recoil, math.Rand(-1,1) *self.Primary.Recoil, 0))
	
	self:TakePrimaryAmmo(1)

	self.Reloadaftershoot = CurTime() + 0.2
	
	self:MuzzleEffect()

	self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)
	
	self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()

end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end

function SWEP:DrawHUD()
self:AmmoTypes()
end