if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "ar2"

if (CLIENT) then
	SWEP.PrintName			= "Grenade Launcher"	
	SWEP.Slot 				= 0
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "h"
	SWEP.ViewModelFOV		= 51

	killicon.AddFont("l4d2_grenadelauncher", "CSKillIcons", SWEP.IconLetter, Color( 0, 200, 0, 255 ) )
end

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 0.55 - hand.Ang:Forward() * 0 + hand.Ang:Up() * 0.8

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 5)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), -3)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(0.9,1.1,1.1))
end
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/v_models/v_grenade_launcher.mdl"
SWEP.WorldModel			= "models/w_models/weapons/w_grenade_launcher.mdl"

SWEP.Primary.Sound			= Sound( "weapons/grenade_launcher/grenadefire/grenade_launcher_fire_1.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 3
SWEP.Primary.Damage 		= 0
SWEP.Primary.NumShots 		= 0
SWEP.Primary.Cone 			= 0
SWEP.Primary.ClipSize 		= 1
SWEP.Primary.Delay 			= 0.3
SWEP.Primary.DefaultClip 	= 20
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "grenade"

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 1
SWEP.Secondary.Automatic 		= false
SWEP.Secondary.Ammo 			= "none"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:LaunchGrenade()

	if (SERVER) then
	local Grenade = ents.Create("l4d2_launchedgrenade")
	local eAng = self.Owner:EyeAngles()
	if !Grenade:IsValid() then return end
	Grenade:SetPos(self.Owner:GetShootPos() + eAng:Right()*3 - eAng:Up()*0.7 + eAng:Forward()*19)
	Grenade.Owner = self.Owner
	Grenade:SetOwner(self.Owner)
	Grenade:SetPhysicsAttacker(self.Owner)
	Grenade:Spawn()
	Grenade:SetAngles(eAng)
	Grenade:SetVelocity(self.Owner:EyeAngles():Forward()*1000 + Vector(0,0,75))
	--Grenade:GetPhysicsObject():AddAngleVelocity(Angle(math.random(-1000,1000),math.random(-1000,1000),math.random(-1000,1000)))
	end

end

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DEPLOY)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self.DoReload = nil
self.Unload = nil
self.DoSmoke = nil
self:EmitSound("weapons/grenade_launcher/grenadeother/grenade_launcher_deploy_1.wav")
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_grenadelauncher")
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
if self.Reloadaftershoot and CurTime() < self.Reloadaftershoot then return end
	if ( self:Clip1() < self.Primary.ClipSize ) and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
		self.Primary.ClipSize = 1
		self:SendWeaponAnim(ACT_VM_RELOAD)
		self:EmitSound("weapons/l4d2_launcher/l4d2_launcher_reload.wav")
		self:SetNWBool("BlurIn",true)
		self.Unblur = CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.5
		self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self.DoReload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 1)
		self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		end
		self.Owner:DoReloadEvent()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

	if self:Clip1() <= 0 or self.Owner:WaterLevel() >= 3 then
	self:SetNextPrimaryFire(CurTime() + 0.5)
	self:EmitSound(self.Primary.EmptySound)
	return end
	
	self:EmitSound(self.Primary.Sound)

	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	self.ReloadTimer = CurTime() + self.Owner:GetViewModel():SequenceDuration()
	
	self:LaunchGrenade()
	self.Owner:ViewPunch(Angle(math.Rand(-0.5,-2.5) * self.Primary.Recoil, math.Rand(-1,1) *self.Primary.Recoil, 0))
	
	self:TakePrimaryAmmo(1)

	self.Reloadaftershoot = CurTime() + 0.2
	
	self:MuzzleEffect()

	self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)
	
	self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()

end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end

function SWEP:DrawHUD()
self:AmmoTypes()
end