if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "smg"

if (CLIENT) then
	SWEP.PrintName			= "M60"	
	SWEP.Slot 				= 0
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "l"
	SWEP.ViewModelFOV		= 57

	killicon.AddFont("l4d2_uzi", "CSKillIcons", SWEP.IconLetter, Color( 0, 200, 0, 255 ) )
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/v_models/v_m60.mdl"
SWEP.WorldModel			= "models/weapons/w_smg1.mdl"

SWEP.Primary.Sound			= Sound( "weapons/50cal/50cal_shoot.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 0.4
SWEP.Primary.Damage 		= 22
SWEP.Primary.NumShots 		= 1
SWEP.Primary.Cone 			= 0.005
if GetConVarNumber("l4d2_real_clips") == 1 then
SWEP.Primary.ClipSize 		= 100
else
SWEP.Primary.ClipSize 		= 150
end
SWEP.Primary.Delay 			= 0.1
SWEP.Primary.DefaultClip 	= 150
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "ar2"

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 1
SWEP.Secondary.Automatic 		= false
SWEP.Secondary.Ammo 			= "gravity"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 21
SWEP.MaxWoodPenetration 	= 26
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DEPLOY)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self.DoReload = nil
self.Unload = nil
self.DoSmoke = nil
self:EmitSound("weapons/rifle_ak47/gunother/rifle_deploy_1.wav")
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_m60")
if self:GetNWBool("Iron") then
self.Owner:SetFOV( 0, 0.2 )
end
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
if !self.Owner:KeyDown(IN_ATTACK) and self.Primary.Cone > 0.005 then
self.Primary.Cone = self.Primary.Cone - 0.001
if self.Primary.Cone < 0.005 then self.Primary.Cone = 0.005 end
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

	if self:Clip1() <= 0 or self.Owner:WaterLevel() >= 3 then
	self:SetNextPrimaryFire(CurTime() + 0.5)
	self:EmitSound(self.Primary.EmptySound)
	return end
	
	self:EmitSound(self.Primary.Sound)
	
	self:SendWeaponAnim(ACT_VM_IDLE)
	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	
	self.Primary.Cone = self.Primary.Cone + 0.001
	if self.Primary.Cone >= 0.016 then self.Primary.Cone = 0.016 end
	
	self:FireBullet(self.Primary.Damage, self.Primary.Recoil, self.Primary.NumShots, self.Primary.Cone)
	self.Owner:ViewPunch(Angle(math.Rand(-0.5,-2.5) * self.Primary.Recoil, math.Rand(-1,1) *self.Primary.Recoil, 0))
	
	self:TakePrimaryAmmo(1)

	self.Reloadaftershoot = CurTime() + 0.2
	
	self.DoSmoke = CurTime() + 1.3
	
	self:MuzzleEffect()

	self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)
	
	self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()

	if self:Clip1() == 0 then
	if (SERVER) then
	self.Owner:StripWeapon("l4d2_m60")
	end
	end
end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end

function SWEP:DrawHUD()
self:AmmoTypes()
end