if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "slam"

if (CLIENT) then
	SWEP.DrawAmmo			= false
	SWEP.PrintName			= "Medkit"	
	SWEP.Slot 				= 3
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "F"
	SWEP.ViewModelFOV		= 50

	killicon.AddFont("l4d2_medkit", "CSKillIcons", SWEP.IconLetterHUD, Color( 0, 200, 0, 255 ) )
end

function SWEP:DrawWeaponSelection(x, y, wide, tall, alpha)

	draw.SimpleText(self.IconLetterHUD, "CSKillIcons", x + wide / 2, y + tall * 0.2, Color(255, 210, 0, 255), TEXT_ALIGN_CENTER)

	self:PrintWeaponInfo(x + wide + 20, y + tall * 0.95, alpha)
end

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 1 - hand.Ang:Forward() * 0 + hand.Ang:Up() * 0

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), -90)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), 0)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(0.74,0.74,0.74))
end
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/v_models/v_medkit.mdl"
SWEP.WorldModel			= "models/w_models/weapons/w_eq_medkit.mdl"

SWEP.Primary.Sound			= Sound( "weapons/smg/gunfire/smg_fire_1.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 0
SWEP.Primary.Damage 		= 0
SWEP.Primary.NumShots 		= 0
SWEP.Primary.Cone 			= 0
SWEP.Primary.ClipSize 		= -1
SWEP.Primary.Delay 			= 0.05
SWEP.Primary.DefaultClip 	= 0
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "none"

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 0
SWEP.Secondary.Automatic 		= true
SWEP.Secondary.Ammo 			= "none"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DEPLOY)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:HealSelfFin()
if self.Owner:Health() >= self.Owner:GetMaxHealth() then return false end
self.Owner:SetHealth(self.Owner:Health() + self.Owner:GetMaxHealth()/1.5)
if self.Owner:Health() >= self.Owner:GetMaxHealth() then self.Owner:SetHealth(self.Owner:GetMaxHealth()) end
if (SERVER) then
self.Owner:StripWeapon("l4d2_medkit")
end
end

function SWEP:HealOtherFin()
local tr = {}
tr.start = self.Owner:GetShootPos()
tr.endpos = self.Owner:GetShootPos() + ( self.Owner:GetAimVector() * 80 )
tr.filter = self.Owner
tr.mask = MASK_SHOT
local trace = util.TraceLine( tr )

if trace.Entity:IsPlayer() and trace.Entity:Health() < trace.Entity:GetMaxHealth() then
trace.Entity:SetHealth(trace.Entity:Health() + trace.Entity:GetMaxHealth()/1.5)
if trace.Entity:Health() >= trace.Entity:GetMaxHealth() then trace.Entity:SetHealth(trace.Entity:GetMaxHealth()) end
if (SERVER) then
self.Owner:StripWeapon("l4d2_medkit")
end
end
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_medkit")
if self:GetNWBool("Iron") then
self.Owner:SetFOV( 0, 0.2 )
end
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()
	
	local tr = {}
	tr.start = self.Owner:GetShootPos()
	tr.endpos = self.Owner:GetShootPos() + ( self.Owner:GetAimVector() * 80 )
	tr.filter = self.Owner
	tr.mask = MASK_SHOT
	local trace = util.TraceLine( tr )
	
	if trace.Hit and trace.Entity:IsPlayer() then
	if not trace.Entity:GetNWInt("Heal_P") then trace.Entity:SetNWInt("Heal_P",0) end
	if trace.Entity:Health() >= trace.Entity:GetMaxHealth() then return false end
	if trace.Entity:GetNWInt("Heal_P") >= 100 then
	trace.Entity:SetNWInt("Heal_P",0)
	self:HealOtherFin()
	return false end
	if trace.Entity:GetNWInt("Heal_P") <= 0 then
	self:EmitSound("player/survivor/heal/bandaging_1.wav")
	end
	trace.Entity:SetNWInt("Heal_P", trace.Entity:GetNWInt("Heal_P") + 1)
	trace.Entity.ResetHealProg = CurTime() + 0.2
	self.Owner:PrintMessage(HUD_PRINTCENTER, ""..trace.Entity:GetNWInt("Heal_P").."")
	end
	
	if self.Owner:GetNWBool("Adrenaline") then
	self:SetNextPrimaryFire(CurTime() + 0.025)
	else
	self:SetNextPrimaryFire(CurTime() + 0.05)
	end

end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
	if not self.Owner:GetNWInt("Heal_P") then self.Owner:SetNWInt("Heal_P",0) end
	if self.Owner:Health() >= self.Owner:GetMaxHealth() then return false end
	if self.Owner:GetNWInt("Heal_P") >= 100 then
	self.Owner:SetNWInt("Heal_P",0)
	self:HealSelfFin()
	return false end
	if self.Owner:GetNWInt("Heal_P") <= 0 then
	self:EmitSound("player/survivor/heal/bandaging_1.wav")
	end
	self.Owner:SetNWInt("Heal_P", self.Owner:GetNWInt("Heal_P") + 1)
	self.Owner.ResetHealProg = CurTime() + 0.2
	self.Owner:PrintMessage(HUD_PRINTCENTER, ""..self.Owner:GetNWInt("Heal_P").."")
	if self.Owner:GetNWBool("Adrenaline") then
	self:SetNextSecondaryFire(CurTime() + 0.025)
	else
	self:SetNextSecondaryFire(CurTime() + 0.05)
	end
end

function SWEP:DrawHUD()
self:AmmoTypes()
end