if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "melee"

if (CLIENT) then
	SWEP.DrawAmmo			= false
	SWEP.PrintName			= "Katana"	
	SWEP.Slot 				= 1
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "j"
	SWEP.ViewModelFOV		= 50

	killicon.AddFont("l4d2_melee_axe", "CSKillIcons", SWEP.IconLetterHUD, Color( 0, 200, 0, 255 ) )
end

SWEP.SpecialMelee = "secondary_swing"

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 0.3 + hand.Ang:Forward() * 0 - hand.Ang:Up() * 0

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), 0)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(1,1,1))
end
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/weapons/melee/v_katana.mdl"
SWEP.WorldModel			= "models/weapons/melee/w_katana.mdl"

local BatSwingSounds = {
"player/survivor/swing/swing_miss1.wav",
"player/survivor/swing/swing_miss2.wav"}

local KatanaHitFleshSounds = {
"weapons/katana/melee_katana_01.wav",
"weapons/katana/melee_katana_02.wav",
"weapons/katana/melee_katana_03.wav"}

local CrowHitWorldSounds = {
"weapons/axe/axe_impact_world1.wav",
"weapons/axe/axe_impact_world2.wav"}

function SWEP:MeleeHit()
local tr = {}
tr.start = self.Owner:GetShootPos()
tr.endpos = self.Owner:GetShootPos() + ( self.Owner:GetAimVector() * 90 )
tr.filter = self.Owner
tr.mask = MASK_SHOT
local trace = util.TraceLine( tr )

if !trace.Hit then return false end

if (trace.Hit) and (trace.Entity:IsPlayer() or trace.Entity:IsNPC() or trace.Entity:GetClass() == "prop_ragdoll" or trace.Entity:GetClass() == "npc_antlion_grub") then
	bullet = {}
	bullet.Num    = 1
	bullet.Src    = self.Owner:GetShootPos()
	bullet.Dir    = self.Owner:GetAimVector()
	bullet.Spread = Vector(0, 0, 0)
	bullet.Tracer = 0
	bullet.Force  = 6
	if trace.Entity:GetClass() == "npc_zombie" or trace.Entity:GetClass() == "npc_vortigaunt" or trace.Entity:GetClass() == "npc_hunter" or trace.Entity:GetClass() == "npc_zombine" or trace.Entity:GetClass() == "npc_antlionguard" or trace.Entity:GetClass() == "npc_zombie_torso" or trace.Entity:GetClass() == "npc_poisonzombie" then
	bullet.Damage = 32
	elseif trace.Entity:GetClass() == "npc_antlion" or trace.Entity:GetClass() == "npc_manhack" or trace.Entity:GetClass() == "npc_cscanner" or trace.Entity:GetClass() == "npc_clawscanner" then
	bullet.Damage = 25
	else
	bullet.Damage = 40
	end
	if self.Owner:GetNWBool("Adrenaline") then
	bullet.Damage = 50
	end
	self:EmitSound(table.Random(KatanaHitFleshSounds,20,100))
	self.Owner:FireBullets(bullet)
	else
	bullet = {}
	bullet.Num    = 1
	bullet.Src    = self.Owner:GetShootPos()
	bullet.Dir    = self.Owner:GetAimVector()
	bullet.Spread = Vector(0, 0, 0)
	bullet.Tracer = 0
	bullet.Force  = 6
	bullet.Damage = 25
	self:EmitSound(table.Random(CrowHitWorldSounds,50,100))
	self.Owner:FireBullets(bullet)
	end
end

SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 0
SWEP.Primary.Damage 		= 0
SWEP.Primary.NumShots 		= 0
SWEP.Primary.Cone 			= 0
SWEP.Primary.ClipSize 		= -1
SWEP.Primary.Delay 			= 0.05
SWEP.Primary.DefaultClip 	= 0
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "none"

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 0
SWEP.Secondary.Automatic 		= true
SWEP.Secondary.Ammo 			= "none"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DRAW)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self:EmitSound("weapons/adrenaline/adrenaline_deploy_1.wav")
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.NomSelf = nil
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_melee_katana")
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.Melee and CurTime() >= self.Melee then
self.Melee = nil
self:MeleeHit()
end
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
end

local KatanaSwingAnim = {
ACT_VM_HITCENTER,
ACT_VM_HITLEFT}

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

local MyAnim = table.Random(KatanaSwingAnim)
	
	self:SendWeaponAnim(MyAnim)
	if MyAnim == ACT_VM_HITLEFT then
	self.Owner:ViewPunch(Angle(0,-3,0))
	elseif MyAnim == ACT_VM_HITCENTER then
	self.Owner:ViewPunch(Angle(0.5,2.5,0))
	end

	self:EmitSound(table.Random(BatSwingSounds))
	
	self.Melee = CurTime() + 0.2
	
	self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
	self.Idle = (CurTime() + self.Owner:GetViewModel():SequenceDuration())

end


/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end

function SWEP:DrawHUD()
self:AmmoTypes()
end