if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "ar2"

if (CLIENT) then
	SWEP.DrawCrosshair		= false
	SWEP.PrintName			= "GS-G31"	
	SWEP.Slot 				= 0
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "i"
	SWEP.ViewModelFOV		= 44

	killicon.AddFont("l4d2_militarysniper", "CSKillIcons", SWEP.IconLetter, Color( 0, 200, 0, 255 ) )
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/v_models/v_sniper_military.mdl"
SWEP.WorldModel			= "models/w_models/weapons/w_sniper_military.mdl"

SWEP.Primary.Sound			= Sound( "weapons/sniper_military/gunfire/sniper_military_fire_1.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 0.3
SWEP.Primary.Damage 		= 20
SWEP.Primary.NumShots 		= 1
SWEP.Primary.Cone 			= 0.001
SWEP.Primary.ClipSize 		= 30
SWEP.Primary.Delay 			= 0.3
SWEP.Primary.DefaultClip 	= 30
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "smg1"

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 0.55 - hand.Ang:Forward() * 0 + hand.Ang:Up() * 0.7

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), -1)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(0.9,1.1,1.1))
end
end

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 1
SWEP.Secondary.Automatic 		= false
SWEP.Secondary.Ammo 			= "none"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:Deploy()
self:CHReloadAT()
self.Owner:GetViewModel():SetSequence(self.Owner:GetViewModel():LookupSequence("deploy_layer"))
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self.Primary.ClipSize 		= 30
self.DoReload = nil
self.Unload = nil
self.DoSmoke = nil
self:EmitSound("weapons/sniper_military/gunother/sniper_military_deploy_1.wav")
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_militarysniper")
if self:GetNWBool("Scoped") then
self:SetNWBool("Scoped",false)
self.Owner:GetViewModel():SetNoDraw(false)
self.Owner:SetFOV( 0, 0.2 )
end
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
if self.Reloadaftershoot and CurTime() < self.Reloadaftershoot then return end
	if ( self:Clip1() < self.Primary.ClipSize ) and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
		if self:GetNWBool("Scoped") then
		self:SetNWBool("Scoped",false)
		self.Owner:GetViewModel():SetNoDraw(false)
		self.Owner:SetFOV( 0, 0.2 )
		self:SetNWBool("ArmsReset",true)
		timer.Simple(0.1, function()
		if self.Owner:IsValid() then
		self:SetNWBool("ArmsReset",false)
		end
		end)
		end
		self.Primary.ClipSize 		= 30
		self:SendWeaponAnim(ACT_VM_RELOAD)
		self:EmitSound("weapons/l4d2_msniper/l4d2_msniper_reload.wav")
		self:SetNWBool("BlurIn",true)
		self.Unblur = CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.5
		self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self.DoReload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 1.4)
		self.Unload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 2.2)
		self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		end
		self.Owner:DoReloadEvent()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self:GetNWBool("Scoped") then
if (CLIENT) then
self.MouseSensitivity = 0.4
end
else
if (CLIENT) then
self.MouseSensitivity = 1
end
end
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
if !self.Owner:KeyDown(IN_ATTACK) and self.Primary.Cone > 0.001 then
self.Primary.Cone = self.Primary.Cone - 0.001
if self.Primary.Cone < 0.001 then self.Primary.Cone = 0.001 end
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

	if self:Clip1() <= 0 or self.Owner:WaterLevel() >= 3 then
	self:SetNextPrimaryFire(CurTime() + 0.5)
	self:EmitSound(self.Primary.EmptySound)
	return end
	
	self:EmitSound(self.Primary.Sound)
	
	self:SendWeaponAnim(ACT_VM_IDLE)
	self.Owner:GetViewModel():SetSequence(self.Owner:GetViewModel():LookupSequence("fire_raw"))
	
	self.Primary.Cone = self.Primary.Cone + 0.001
	if self.Primary.Cone >= 0.016 then self.Primary.Cone = 0.016 end
	
	self:FireBullet(self.Primary.Damage, self.Primary.Recoil, self.Primary.NumShots, self.Primary.Cone)
	self.Owner:ViewPunch(Angle(math.Rand(-0.5,-2.5) * self.Primary.Recoil, math.Rand(-1,1) *self.Primary.Recoil, 0))
	
	self:TakePrimaryAmmo(1)

	self.Reloadaftershoot = CurTime() + 0.2
	
	self.DoSmoke = CurTime() + 1.3
	
	self:MuzzleEffect()

	self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)
	
	self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()

end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
if not self:GetNWBool("Scoped") then
self:SetNWBool("Scoped",true)
self.Owner:GetViewModel():SetNoDraw(true)
self.Owner:SetFOV( 30, 0.2 )
self:EmitSound("weapons/sniper_military/gunother/sniper_military_zoom.wav")
else
self:SetNWBool("Scoped",false)
self.Owner:GetViewModel():SetNoDraw(false)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self.Owner:SetFOV( 0, 0.2 )
self:EmitSound("weapons/sniper_military/gunother/sniper_military_zoom.wav",75,120)
end
end

function SWEP:DrawHUD()
	if (CLIENT) then
	
	local Scale = ScrH()/480
	local w, h = 320*Scale, 240*Scale
	local cx, cy = ScrW()/2, ScrH()/2
	local scope_sniper_lr = surface.GetTextureID("sprites/scopes/scope_spring_lr")
	local scope_sniper_ll = surface.GetTextureID("sprites/scopes/scope_spring_ll")
	local scope_sniper_ul = surface.GetTextureID("sprites/scopes/scope_spring_ul")
	local scope_sniper_ur = surface.GetTextureID("sprites/scopes/scope_spring_ur")
	local SNIPERSCOPE_MIN = -0.75
	local SNIPERSCOPE_MAX = -2.782
	local SNIPERSCOPE_SCALE = 0.4
	--gets the center of the screen
	local x = ScrW() / 2.0
	local y = ScrH() / 2.0
 
	--set the drawcolor
	surface.SetDrawColor( 0, 0, 0, 255 )
 	local gap = 0
	local length = gap + 9999
	
	if self:GetNWBool("Scoped") then 

	surface.DrawLine( x - length, y, x - gap, y )
	surface.DrawLine( x + length, y, x + gap, y )
	surface.DrawLine( x, y - length, x, y - gap )
	surface.DrawLine( x, y + length, x, y + gap )
	render.UpdateRefractTexture()
	surface.SetDrawColor(255,255,255,255)
	surface.SetTexture(scope_sniper_lr) surface.DrawTexturedRect(cx    , cy    , w, h)
	surface.SetTexture(scope_sniper_ll) surface.DrawTexturedRect(cx - w    , cy    , w, h)
	surface.SetTexture(scope_sniper_ul) surface.DrawTexturedRect(cx - w    , cy - h    , w, h)
	surface.SetTexture(scope_sniper_ur) surface.DrawTexturedRect(cx    , cy - h    , w, h)
	surface.SetDrawColor(0,0,0,255)
	if cx-w > 0 then
	surface.DrawRect(0, 0, cx-w, ScrH())
	surface.DrawRect(cx+w, 0, cx-w, ScrH())
	end
	end
end
self:AmmoTypes()
end