if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "ar2"

if (CLIENT) then
	SWEP.PrintName			= "FN Scar-H"	
	SWEP.Slot 				= 0
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "v"
	SWEP.ViewModelFOV		= 48

	killicon.AddFont("l4d2_scar", "CSKillIcons", SWEP.IconLetter, Color( 0, 200, 0, 255 ) )
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.StaminaWeight = 0.9

SWEP.ViewModel			= "models/v_models/v_desert_rifle.mdl"
SWEP.WorldModel			= "models/w_models/weapons/w_rifle_b.mdl"

SWEP.Primary.Sound			= Sound( "weapons/rifle_desert/gunfire/rifle_fire_1.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 0.3
SWEP.Primary.Damage 		= 13
SWEP.Primary.NumShots 		= 1
SWEP.Primary.Cone 			= 0.005
if GetConVarNumber("l4d2_real_clips") == 1 then
SWEP.Primary.ClipSize 		= 30
else
SWEP.Primary.ClipSize 		= 60
end
SWEP.Primary.Delay 			= 0.08
SWEP.Primary.DefaultClip 	= 60
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "smg1"

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 0 - hand.Ang:Forward() * 2.3 - hand.Ang:Up() * 0

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), -3)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(1.15,1.15,1.15))
end
end

SWEP.HasEmptyAnims = true

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 1
SWEP.Secondary.Automatic 		= false
SWEP.Secondary.Ammo 			= "none"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DEPLOY)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
self:EmitSound("weapons/rifle_desert/gunother/rifle_deploy_1.wav")
if GetConVarNumber("l4d2_real_clips") == 1 then
self.Primary.ClipSize 		= 30
else
self.Primary.ClipSize 		= 60
end
self.DoReload = nil
self.Unload = nil
self.DoSmoke = nil
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:Holster()
self:StopSmoke()
self.Owner:SetNWInt("LastWeapon", "l4d2_m4")
if self:GetNWBool("Iron") then
self.Owner:SetFOV( 0, 0.2 )
end
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
if self.Reloadaftershoot and CurTime() < self.Reloadaftershoot then return end
	if ( self:Clip1() < self.Primary.ClipSize ) and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
		if GetConVarNumber("l4d2_real_clips") == 1 then
		self.Primary.ClipSize 		= 30
		else
		self.Primary.ClipSize 		= 60
		end
		self:SendWeaponAnim(ACT_VM_RELOAD)
		self:EmitSound("weapons/l4d2_drifle/l4d2_drifle_reload2.wav")
		self:SetNWBool("BlurIn",true)
		self.Unblur = CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.5
		self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self.DoReload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 1.4)
		self.Unload = (CurTime() + self.Owner:GetViewModel():SequenceDuration() - 2.2)
		self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		end
		self.Owner:DoReloadEvent()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.ResetBurst and CurTime() >= self.ResetBurst then
self.ResetBurst = nil
self:SetNWInt("B_Count",0)
end
if self.Idle and CurTime() >= self.Idle then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
if !self.Owner:KeyDown(IN_ATTACK) and self:GetNWInt("B_Count") > 0 then
self:SetNWInt("B_Count",0)
end
if !self.Owner:KeyDown(IN_ATTACK) and self.Primary.Cone > 0.005 then
self.Primary.Cone = self.Primary.Cone - 0.001
if self.Primary.Cone < 0.005 then self.Primary.Cone = 0.005 end
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

	if self:Clip1() <= 0 or self.Owner:WaterLevel() >= 3 then
	self:SetNextPrimaryFire(CurTime() + 0.5)
	self:EmitSound(self.Primary.EmptySound)
	return end
	
	if GetConVarNumber("l4d2_desertrifle_isauto") == 0 then
	if self:GetNWInt("B_Count") >= 3 then return false end
	self:SetNWInt("B_Count", self:GetNWInt("B_Count") + 1)
	if self:GetNWInt("B_Count") >= 3 then self.ResetBurst = CurTime() + 0.25 end
	end
	
	self:EmitSound(self.Primary.Sound)
	
	if self:Clip1() == 1 then
	self:SendWeaponAnim(ACT_VM_IDLE)
	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	self.ReloadTimer = CurTime() + self.Owner:GetViewModel():SequenceDuration()
	else
	self:SendWeaponAnim(ACT_VM_IDLE)
	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	end
	
	self.Primary.Cone = self.Primary.Cone + 0.001
	if self.Primary.Cone >= 0.016 then self.Primary.Cone = 0.016 end
	
	self:FireBullet(self.Primary.Damage, self.Primary.Recoil, self.Primary.NumShots, self.Primary.Cone)
	self.Owner:ViewPunch(Angle(math.Rand(-0.5,-2.5) * self.Primary.Recoil, math.Rand(-1,1) *self.Primary.Recoil, 0))
	
	self:TakePrimaryAmmo(1)

	self.Reloadaftershoot = CurTime() + 0.2
	
	self.DoSmoke = CurTime() + 1.3
	
	self:MuzzleEffect()

	self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)
	
	self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()

end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end

function SWEP:DrawHUD()
self:AmmoTypes()
end