if (SERVER) then
	AddCSLuaFile("shared.lua")
end

SWEP.HoldType		= "shotgun"

local InsertShell = {
"weapons/l4d2_shotgun/shotgun_Linsert1.wav",
"weapons/l4d2_shotgun/shotgun_Linsert2.wav"}

local FInsertShell = {
"weapons/l4d2_shotgun/shotgun_insert1.wav",
"weapons/l4d2_shotgun/shotgun_insert2.wav"}

if (CLIENT) then
	SWEP.PrintName			= "Spas-12"	
	SWEP.Slot 				= 0
	SWEP.SlotPos 			= 1
	SWEP.IconLetterHUD		= "k"
	SWEP.ViewModelFOV		= 48

	killicon.AddFont("l4d2_spas", "CSKillIcons", SWEP.IconLetter, Color( 0, 200, 0, 255 ) )
end

function SWEP:EjectBrass()
end

SWEP.Instructions 			= ""
SWEP.Author   				= "Zoey"
SWEP.Contact        		= ""

SWEP.Base 				= "l4d2_base"
SWEP.ViewModelFlip		= false

SWEP.StaminaWeight = 1.15

SWEP.LowAmmoCap = true

SWEP.Spawnable 			= false
SWEP.AdminSpawnable 	= true

SWEP.ViewModel			= "models/v_models/v_shotgun_spas.mdl"
SWEP.WorldModel			= "models/w_models/weapons/w_shotgun_spas.mdl"

SWEP.Primary.Sound			= Sound( "weapons/auto_shotgun_spas/gunfire/shotgun_fire_1.wav" )
SWEP.Primary.EmptySound		= Sound( "Weapon_Pistol.Empty" )
SWEP.Primary.Recoil 		= 2
SWEP.Primary.Damage 		= 9
SWEP.Primary.NumShots 		= 13
SWEP.Primary.Cone 			= 0.1
if GetConVarNumber("l4d2_real_clips") == 1 then
SWEP.Primary.ClipSize 		= 8
else
SWEP.Primary.ClipSize 		= 10
end
SWEP.Primary.Delay 			= 0.3
SWEP.Primary.DefaultClip 	= 10
SWEP.Primary.Automatic 		= true
SWEP.Primary.Ammo 			= "buckshot"

SWEP.Secondary.ClipSize 		= -1
SWEP.Secondary.DefaultClip 	= 1
SWEP.Secondary.Automatic 		= false
SWEP.Secondary.Ammo 			= "gravity"

SWEP.IronSightsPos = Vector (0,0,0)
SWEP.IronSightsAng = Vector (0,0,0)

SWEP.Penetration			= false
SWEP.MaxPenetration 		= 19
SWEP.MaxWoodPenetration 	= 24
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 0

function SWEP:DrawWorldModel()

local hand, offset, rotate

if not ValidEntity(self.Owner) then
self:DrawModel()
return
end

hand = self.Owner:GetAttachment(self.Owner:LookupAttachment("anim_attachment_rh"))

offset = hand.Ang:Right() * 0.55 - hand.Ang:Forward() * 0.2 + hand.Ang:Up() * 0.7

hand.Ang:RotateAroundAxis(hand.Ang:Right(), 5)
hand.Ang:RotateAroundAxis(hand.Ang:Forward(), 0)
hand.Ang:RotateAroundAxis(hand.Ang:Up(), -1)

self:SetRenderOrigin(hand.Pos + offset)
self:SetRenderAngles(hand.Ang)

self:DrawModel()

if (CLIENT) then
self:SetModelScale(Vector(0.9,1.1,1.1))
end
end

function SWEP:Deploy()
self:CHReloadAT()
self:SendWeaponAnim(ACT_VM_DEPLOY)
self:SetNWBool("ArmsReset",true)
timer.Simple(0.1, function()
if self.Owner:IsValid() then
self:SetNWBool("ArmsReset",false)
end
end)
if GetConVarNumber("l4d2_real_clips") == 1 then
self.Primary.ClipSize 		= 8
else
self.Primary.ClipSize 		= 10
end
self.DoReload2 = nil
self.DoSmoke = nil
self:EmitSound("weapons/rifle_ak47/gunother/rifle_deploy_1.wav")
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.CustomPunch = nil
self:SetNWBool("SafeSprint",false)
self:SetNWBool("Reload",false)
self:SetNWBool("Iron",false)
return true
end

function SWEP:Holster()
self:StopSmoke()
self.CustomPunch = nil
self.Owner:SetNWInt("LastWeapon", "l4d2_spas")
if self:GetNWBool("Iron") then
self.Owner:SetFOV( 0, 0.2 )
end
return true
end

/*---------------------------------------------------------
Reload
---------------------------------------------------------*/
function SWEP:Reload()
	if ( self:Clip1() < self.Primary.ClipSize ) and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 and !self:GetNWBool("Reload") then
		self:SetNWBool("Reload",true)
		self:SendWeaponAnim(ACT_VM_RELOAD)
		self:SetNWBool("BlurIn",true)
		self.Idle = nil
		self.CustomPunch = nil
		self:EmitSound(table.Random(FInsertShell))
		self:SetClip1(self:Clip1() + 1)
		self.Owner:RemoveAmmo( 1, self.Primary.Ammo )
		self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
		self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		self.DoReload2 = CurTime() + self.Owner:GetViewModel():SequenceDuration()
		end
		self.Owner:DoReloadEvent()
end

/*---------------------------------------------------------
Think
---------------------------------------------------------*/
function SWEP:Think()
self:ReloadTimers()
if self.TimedReset and CurTime() >= self.TimedReset then
self.TimedReset = nil
self:SetNWBool("Reload",false)
end
if self.DoReload2 and CurTime() >= self.DoReload2 and self:GetNWBool("Reload") then
if self:Clip1() >= self.Primary.ClipSize or self:Ammo1() <= 0 then
self.Owner:GetViewModel():SetSequence(self.Owner:GetViewModel():LookupSequence("reload_end"))
self:EmitSound("weapons/l4d2_spas/l4d2_spas_end.wav")
self.Unblur = CurTime()
self.CustomPunch = nil
self.TimedReset = CurTime() + self.Owner:GetViewModel():SequenceDuration()*0.5
self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.DoReload2 = nil
else
self.Owner:GetViewModel():SetSequence(self.Owner:GetViewModel():LookupSequence("reload_loop"))
self.CustomPunch = CurTime() + 0.5
self:EmitSound(table.Random(InsertShell))
self:SetClip1(self:Clip1() + 1)
self.Owner:RemoveAmmo( 1, self.Primary.Ammo )
self.Idle = nil
self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration() -0.1)
self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration() -0.1)
self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
self.DoReload2 = CurTime() + self.Owner:GetViewModel():SequenceDuration()
end
end
if self.Idle and CurTime() >= self.Idle and !self:GetNWBool("Reload") then
self.Idle = nil
self:SendWeaponAnim(ACT_VM_IDLE)
end
end

/*---------------------------------------------------------
PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

	if self:GetNWBool("Reload") then
	self.Owner:GetViewModel():SetSequence(self.Owner:GetViewModel():LookupSequence("reload_end"))
	self:EmitSound("weapons/l4d2_spas/l4d2_spas_end.wav")
	self.Unblur = CurTime()
	self.TimedReset = CurTime() + self.Owner:GetViewModel():SequenceDuration()*0.5
	self.CustomPunch = nil
	self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration()
	self:SetNextPrimaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
	self:SetNextSecondaryFire(CurTime() + self.Owner:GetViewModel():SequenceDuration())
	self.SafetyDelay = CurTime() + self.Owner:GetViewModel():SequenceDuration()
	self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()
	self.DoReload2 = nil
	return false
	end

	if self:Clip1() <= 0 or self.Owner:WaterLevel() >= 3 then
	self:SetNextPrimaryFire(CurTime() + 0.5)
	self:EmitSound(self.Primary.EmptySound)
	return end
	
	self:EmitSound(self.Primary.Sound,75,math.random(98,102))
	
	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	
	self:FireBullet(self.Primary.Damage, self.Primary.Recoil, self.Primary.NumShots, self.Primary.Cone)
	self.Owner:ViewPunch(Angle(math.Rand(-0.5,-2.5) * self.Primary.Recoil, math.Rand(-1,1) *self.Primary.Recoil, 0))
	
	self:TakePrimaryAmmo(1)
	
	self.Idle = CurTime() + self.Owner:GetViewModel():SequenceDuration()

	self.Reloadaftershoot = CurTime() + 0.2
	
	self.DoSmoke = CurTime() + 1.3
	
	self:MuzzleEffect()

	self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)

	self.Reloadaftershoot = CurTime() + self.Owner:GetViewModel():SequenceDuration() - 0.25

end

/*---------------------------------------------------------
SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
end

function SWEP:DrawHUD()
self:AmmoTypes()
end